<!-- src/views/RegisterPage.vue -->

<template>
  <div class="mt-2 lg:mt-8 pb-1 lg:pb-3 text-center">
    <h1>Registration</h1>
  </div>

  <div class="grid formgrid p-fluid p-2 w-full lg:w-4 m-auto">
    <div class="field mb-4 col-12">
      <InputText v-model="email" type="text" placeholder="Email" />
    </div>

    <div class="field mb-4 col-12">
      <InputText v-model="name" type="text" placeholder="Name" />
    </div>

    <div class="field mb-4 col-12">
      <InputText v-model="studentId" type="text" placeholder="Student ID" />
    </div>

    <div class="field mb-4 col-12">
      <InputText v-model="password" type="password" placeholder="Password" />
    </div>

    <div class="field mb-4 col-12">
      <InputText v-model="passwordConfirm" type="password" placeholder="Confirm Password" />
    </div>

    <div class="col-12 mb-4 flex justify-content-center">
      <Button
        label="REGISTER"
        class="w-auto border-round-lg mt-3 px-8"
        :disabled="!canRegister"
        @click="register"
      ></Button>
    </div>

    <div class="col-12 text-center text-gray-500">
      <a href="/login">To Login Page</a>
    </div>
  </div>
</template>

<script setup>
import { ref, computed } from 'vue';
import { useUserStore } from '@/stores/userStore';
import { useRouter } from 'vue-router';

const userStore = useUserStore();
const router = useRouter();
const email = ref('');
const name = ref('');
const studentId = ref('');
const password = ref('');
const passwordConfirm = ref('');

const canRegister = computed(() => {
  return (
    email.value.trim() !== '' &&
    name.value.trim() !== '' &&
    studentId.value.trim() !== '' &&
    password.value.trim() !== '' &&
    password.value === passwordConfirm.value
  );
});

const register = async () => {
  try {
    await userStore.register(email.value, name.value, studentId.value, password.value);
    alert('Registration successful');
    router.push('/upload');
  } catch (error) {
    alert('Registration failed: ' + error.message);
  }
};
</script>
